package com.jclark.xsl;

class AncestorQualifier extends Qualifier {
  private Matcher pattern;

  AncestorQualifier(Matcher pattern, Qualifier next) {
    super(next);
    this.pattern = pattern;
  }

  boolean matches(ProcessContext context, Node node, int maxAncestors) {
    do {
      if (maxAncestors-- == 0)
	return false;
      node = node.getParent();
      if (node == null)
	return false;
    } while (!pattern.matches(context, node));
    return true;
  }

  int getSpecificity() {
    return pattern.getSpecificity();
  }

}
