package com.jclark.xsl;

class ElementPattern extends QualifiedPattern {
  private Name name;

  ElementPattern(Name name, Qualifier qualifier) {
    super(qualifier);
    this.name = name;
  }

  public boolean matches(ProcessContext context, Node node, int maxAncestors) {
    return node.getType() == Node.ELEMENT && node.getName().equals(name) && super.matches(context, node, maxAncestors);
  }

  public Name getMatchName() {
    return name;
  }

  public int getSpecificity() {
    return 1 + super.getSpecificity();
  }
}
