package com.jclark.xsl;

class FirstOfAnyQualifier extends Qualifier {
  private boolean negated;
  FirstOfAnyQualifier(boolean negated, Qualifier next) {
    super(next);
    this.negated = negated;
  }
  boolean matches(ProcessContext context, Node node, int maxAncestors) {
    for (NodeIterator iter = node.getParent().getChildren(true);;) {
      Node tem = iter.next();
      if (tem.equals(node))
	break;
      if (tem.getType() == Node.ELEMENT)
	return negated ? true : false;
    }
    return negated ? false : true;
  }
}
