package com.jclark.xsl;

class IfAction implements Action {
  Condition condition;
  Action ifTrueAction;
  Action ifFalseAction;

  IfAction(Condition condition, Action ifTrueAction, Action ifFalseAction) {
    this.condition = condition;
    this.ifTrueAction = ifTrueAction;
    this.ifFalseAction = ifFalseAction;
  }

  public void invoke(ProcessContext context, Node sourceNode, Result result) throws XSLException {
    if (condition.satisfied(context, sourceNode))
      ifTrueAction.invoke(context, sourceNode, result);
    else
      ifFalseAction.invoke(context, sourceNode, result);
  }
}
