package com.jclark.xsl;

class LiteralElementAction implements Action {
  Name name;
  AttributeListTemplate attributesTemplate;
  NamespacePrefixMap nsMap;
  Action content;

  LiteralElementAction(Name name, AttributeListTemplate attributesTemplate, NamespacePrefixMap nsMap, Action content) {
    this.name = name;
    this.attributesTemplate = attributesTemplate;
    this.nsMap = nsMap;
    this.content = content;
  }

  public void invoke(ProcessContext context, Node sourceNode, Result result) throws XSLException {
    result.element(name,
		   attributesTemplate.instantiate(context, sourceNode),
		   nsMap,
		   content,
		   context,
		   sourceNode);
  }

}
