package com.jclark.xsl;

class SingleLevelNumberAction implements Action {
  private Matchable count;
  private Matchable from;
  private NumberListFormatTemplate formatTemplate;
  SingleLevelNumberAction(Matchable count, Matchable from, NumberListFormatTemplate formatTemplate) {
    this.count = count;
    this.from = from;
    this.formatTemplate = formatTemplate;
  }
  public void invoke(ProcessContext context, Node node, Result result) throws XSLException {
    NumberListFormat format = formatTemplate.instantiate(context, node);
    result.characters(format.getPrefix(0));
    if (count == null) {
      if (node.getType() == Node.ELEMENT) {
	Name name = node.getName();
	int n = 0;
	for (NodeIterator iter = node.getParent().getChildren(true);;) {
	  Node tem = iter.next();
	  if (name.equals(tem.getName()) && tem.getType() == Node.ELEMENT) {
	    n++;
	    if (tem.equals(node))
	      break;
	  }
	}
	result.characters(format.formatNumber(0, n));
      }
    }
    else {
      do {
	Node parent = node.getParent();
	if (count.matches(context, node)) {
	  int n = 0;
	  for (NodeIterator iter = parent.getChildren(true);;) {
	    Node tem = iter.next();
	    if (count.matches(context, tem)) {
	      ++n;
	      if (tem.equals(node))
		break;
	    }
	  }
	  result.characters(format.formatNumber(0, n));
	}
	if (from != null && from.matches(context, node))
	  break;
	node = parent;
      } while (node != null);
    }
    result.characters(format.getSuffix());
  }
}
